var for_each = Function.prototype.call.bind(Array.prototype.forEach);
var every = Function.prototype.call.bind(Array.prototype.every);
var map = Function.prototype.call.bind(Array.prototype.map);
var contains = Function.prototype.call.bind(function(element) {
  return Array.prototype.indexOf.call(this, element) !== -1;
});

function todo(message) {
  console.log(message || 'Not implemented');
}

function doNothing() {}
function print() {
  console.log.apply(console, arguments);
}

function classesToSelector(list, isMultiClassesItem) {
  if (!list) {
    return '';
  }

  if (Array.isArray(list)) {
    if (!list.length){
      return '';
    }
  } else {
    list = [list];
  }

  return '.' + list.join(isMultiClassesItem ? '.' : ', .');
}

function idToSelector(id) {
  return '#' + id;
}

function areElementsDifferent(element1, element2) {
  var tmp;

  element1 = element1.cloneNode(true);
  element2 = element2.cloneNode(true);

  if (element1 instanceof DocumentFragment) {
    tmp = window.bragi.createTemplate(['div']);
    tmp.appendChild(element1);
    element1 = tmp;
  }

  if (element2 instanceof DocumentFragment) {
    tmp = window.bragi.createTemplate(['div']);
    tmp.appendChild(element2);
    element2 = tmp;
  }

  return element1.innerHTML !== element2.innerHTML;
}

function renderTemplateIfNeeded(element, template) {
  if (areElementsDifferent(element, window.bragi.createTemplate(template))) {
    element.cleanAppendTemplate(template);
  }
}

function bindOnce(fn, obj) {
  var entry = bindOnce.bound_.filter(function(entry) {
    return entry.obj === obj && entry.fn === fn;
  })[0];

  if (entry) {
    return entry.fnBound;
  } else {
    var fnBound = function() {
      try {
        if (!window || !obj) {
          return;
        }
        return fn.apply(obj, arguments);
      } catch (e) {
        throw(e);
      }
    };

    bindOnce.bound_.push({
      obj: obj,
      fn: fn,
      fnBound: fnBound
    });

    return fnBound;
  }
}

bindOnce.bound_ = [];

chrome.extension.ViewType = chrome.extension.ViewType || {
      'TAB': 'tab',
      'POPUP': 'popup',
      'SIDEBAR_PANEL': 'sidebar_panel'
    };

chrome.runtime.PlatformOs = chrome.runtime.PlatformOs || {
      'ANDROID': 'android',
      'CROS': 'cros',
      'LINUX': 'linux',
      'MAC': 'mac',
      'OPENBSD': 'openbsd',
      'WIN': 'win'
    };