'use strict';

var app = new App();

var analytics = new Analytics();
var networkTasks = new NetworkTasks();
var api = new Api();
var offroad = new OffRoad();
var sessionCookie = new SessionCookie();
var device = new Device();
var dataPlan = new DataPlan();
var geo = new Geo();
var rewards = new Rewards();
var user = new User();
var proxy = new Proxy();

var errors = new Errors();
var browsingActivity = new BrowsingActivity();
var notifications = new Notifications();
var toolbarState = new ToolbarState();

app.isReady = true;

window.addEventListener('unload', function() {
  chrome.extension.getViews().forEach(function(view) {
    if (view !== window) {
      view.close();
    }
  });
}, true);

if (chrome.privacy.network.webRTCIPHandlingPolicy) {
  if (chrome.privacy.network.webRTCMultipleRoutesEnabled) {
    chrome.privacy.network.webRTCMultipleRoutesEnabled.clear({});
  }

  if (chrome.privacy.network.webRTCNonProxiedUdpEnabled) {
    chrome.privacy.network.webRTCMultipleRoutesEnabled.clear({});
  }

  chrome.privacy.network.webRTCIPHandlingPolicy.set({
    'value': chrome.privacy.IPHandlingPolicy.DISABLE_NON_PROXIED_UDP
  });
} else {
  if (chrome.privacy.network.webRTCMultipleRoutesEnabled) {
    chrome.privacy.network.webRTCMultipleRoutesEnabled.set({
      'value': false
    });
  }

  if (chrome.privacy.network.webRTCNonProxiedUdpEnabled) {
    chrome.privacy.network.webRTCNonProxiedUdpEnabled.set({
      'value': false
    });
  }
}