'use strict';

class Dev extends AbstractSite {
  constructor() {
    super(Dev.ID);

    this.addView(new DevView());
    this.initialize();
  }

  render() {
    this.siteElement_ = document.body.appendTemplate(
        this.Templates.view(this.id));
  }

  onCanShowChanged_() {
    super.onCanShowChanged_();

    if (!this.currentView) {
      this.close();
    }
  }

  close() {
    Url.close(window.location.href);
  }
};

Dev.Templates = class extends AbstractSite.Templates {
  static header() {
    return [
      'header',
      ['div', {'class': 'icon-logo'}],
      ['div', {'id': AbstractSite.ID_HEADER}]
    ]
  }

  static view(id) {
    return [
      'div', {
        'id': id + '-wrap'
      },
      super.view(id)
    ];
  }
};

Dev.ID = 'dev';

document.addEventListener('DOMContentLoaded', function() {
  chrome.runtime.getBackgroundPage(function(backgroundPage) {
    window.Url = backgroundPage.Url;
    window.api = backgroundPage.api;
    window.Api = backgroundPage.Api;
    window.App = backgroundPage.App;
    window.app = backgroundPage.app;
    window.analytics = backgroundPage.analytics;
    window.user = backgroundPage.user;

    window.site = new Dev();
  });
});