'use strict';

class IpPage extends AbstractPage {
  constructor() {
    super(IpPage.ID);
    this.registerListeners_();
  }

  registerListeners_() {
    super.registerListeners_();
    Geo.Events.onChanged.addListener(bindOnce(this.onGeoChanged_, this));
  }

  unregisterListeners_() {
    super.unregisterListeners_();
    Geo.Events.onChanged.removeListener(bindOnce(this.onGeoChanged_, this));
  }

  onGeoChanged_() {
    if (this.isVisible) {
      this.render();
    }
  }

  render() {
    var serverIP = geo.serverLocation.ip ? geo.serverLocation.ip : null;
    var userIP = geo.userLocation ? geo.userLocation.ip : null;
    renderTemplateIfNeeded(this.viewElement,
                           this.Templates.view(serverIP, userIP));
  }
};

IpPage.Templates = class {
  static view(serverIP, userIP) {
    return [
      (serverIP ? [
        'section', {
          'class': 'is-public'
        },
        ['h4', i18n.get('ipPageServerIPTitle')],
        ['h3', serverIP]
      ] : null),
      (userIP ? [
        'section', {
          'class': 'is-private'
        },
        ['h4', i18n.get('ipPageUserIPTitle')],
        ['h3', userIP]
      ]: null)
    ];
  }
};

IpPage.ID = 'ip';
