'use strict';

class WelcomeRewardPage extends AbstractPage {
  constructor() {
    super(WelcomeRewardPage.ID);

    this.registerListeners_();
  }

  get rewardItem() {
    return rewards.getItem(Reward.REWARD_WELCOME);
  }

  render() {
    renderTemplateIfNeeded(this.viewElement,
        this.Templates.view(this.rewardItem));
  }
};

WelcomeRewardPage.Templates = class extends AbstractPageView.Templates {
  static header() {
    return [
      'h2',
      ['strong', i18n.get('welcomeTitle')],
      ['span', i18n.get('welcomeSubtitle')]
    ]
  }

  static view(reward) {
    return [
      this.header(),
      this.article(reward)
    ];
  }

  static article(reward) {
    return [
      'article',
      [
        'header',
        [
          'p',
          i18n.getTemplate('rewardWelcomeDescription', {
                '$1': [
                  'div',
                  [
                    'strong',
                    reward.amount + Reward.REWARD_AMOUNT_UNIT
                  ]
                ]
              })
        ]
      ],
      [
        'section',
        ['h3', i18n.get('welcomeDataPlanTitle')],
        [
          'div',
          [
            'section', {
            'class': 'icon-plus'
          },
            ['h5', i18n.get('welcomeDataPlanFreeTitle')],
            ['h6', i18n.get('welcomeDataPlanFreeDescription')]
          ],
          [
            'section',{
            'class': 'icon-infinity'
          },
            ['h5', i18n.get('welcomeDataPlanUnlimitedTitle')],
            ['h6', i18n.get('welcomeDataPlanUnlimitedDescription')]
          ]
        ]
      ]
    ];
  }
};

WelcomeRewardPage.ID = 'welcome-reward';
