'use strict';

class LandingLoginForm extends LoginForm {
  constructor() {
    super();
    this.title_= i18n.get('landingPageSignLoginTitle');
  }
};

LandingLoginForm.Templates = class extends LoginForm.Templates {
  static header() {
    return [
      'h1',
      ['strong', i18n.get('landingPageSignTitle')],
      ['span', i18n.get('landingPageSignLoginTitle')]
    ];
  }

  static summary(canRegister) {
    return [
      'div', {
        'class': 'summary'
      },
      this.buttonSubmit(),
      (canRegister ? this.linkGoRegister() : null)
    ];
  }

  static view(data) {
    return this.form(data);
  }
};

LandingLoginForm.ID = LoginForm.ID;