'use strict';

class LandingWelcomeRewardsView extends WelcomeRewardsView {
  constructor() {
    super();
  }

  set currentPageID(value) {}

  render() {
    renderTemplateIfNeeded(this.viewElement, this.Templates.view());

    this.attachSubpages_(this.viewElement, [
      LandingWelcomeRewardPage.ID,
      LandingNumberRewardForm.ID
    ]);

    renderTemplateIfNeeded(this.headerElement, this.Templates.header());
    renderTemplateIfNeeded(this.footerElement, this.Templates.footer());
  }

  onRewardCompleteChanged_() {
    if (this.numberInputReward.isCompleted && !this.welcomeReward.isCompleted) {
      this.welcomeReward.isCompleted = true;
    } else {
      super.onRewardCompleteChanged_();
    }
  }
};

LandingWelcomeRewardsView.Templates =
    class extends WelcomeRewardsView.Templates {
  static footer() {
    return Landing.Templates.moreForNewUser();
  }

  static welcomeRewardView() {
    return super.page();
  }

  static view() {
    return [
      this.welcomeRewardView(),
      this.numberInputRewardView()
    ];
  }
};

LandingWelcomeRewardsView.ID = WelcomeRewardsView.ID;
