'use strict';

class AbstractDataHomeView extends AbstractHomeView {
  constructor(id) {
    super(id);
  }

  get isShowable() {
    return !dataPlan.isUnlimited;
  }

  get templateData_() {
    var data = super.templateData_;
    data.isExpired = dataPlan.isOverBandwidth;
    data.isRewardable = dataPlan.isRewardable;

    return data;
  }

  registerHandlers_() {
    super.registerHandlers_();
    EventHandler.register('click', AbstractDataHomeView.HANDLER_UPGRADE,
                          bindOnce(this.onUpgrade_, this));
  }

  unregisterHandlers_() {
    super.unregisterHandlers_();
    EventHandler.unregister('click', AbstractDataHomeView.HANDLER_UPGRADE,
                            bindOnce(this.onUpgrade_, this));
  }

  onUpgrade_() {
    dataPlan.purchase();
  }
};

AbstractDataHomeView.Templates = class extends AbstractHomeView.Templates {
  static upgradeButton() {
    return [
      'button', {
        'class': 'highlighted',
        'data-handler': AbstractDataHomeView.HANDLER_UPGRADE
      },
      i18n.get('buttonUpgrade')
    ];
  }

  static rewardsItem() {
    return [
      'div', {
        'class': 'list-item is-link has-icon icon-plus-gray',
        'data-handler': AbstractPageView.HANDLER_NAVIGATE_TO_PAGE,
        'data-page': RewardsPage.ID
      },
      i18n.get('homeLabelRewards')
    ];
  }

  static list(data, items) {
    items = items || [];

    if (data.isRewardable) {
      items.push(this.rewardsItem());
    }

    return super.list(data, items);
  }

  static view(data) {
    var template = super.view(data);
    template.push(this.upgradeButton());
    return template;
  }
};

AbstractDataHomeView.HANDLER_UPGRADE = 'home-free-upgrade';
AbstractDataHomeView.APPLY_DATA_USAGES_TIMEOUT = 1000;