'use strict';

class AbstractDataPlanPage extends AbstractPlanPage {
  constructor(id) {
    super(id);
  }

  render() {
    super.render();
    this.applyDataUsages_();
  }

  applyDataUsages_() {
    if (this.applyDataUsagesCancel_) {
      this.applyDataUsagesCancel_();
      this.applyDataUsagesCancel_ = null;
    }

    if (!this.viewElement.querySelector('.ring')) {
      return;
    }

    new Promise(function(resolve, reject) {
      this.applyDataUsagesCancel_ = reject;
      setTimeout(resolve, AbstractDataHomeView.APPLY_DATA_USAGES_TIMEOUT);
    }.bind(this)).then(function() {
      var ring = this.viewElement.querySelector('.ring');
      if (ring && dataPlan.data) {
        var colorIndicator = Math.round(Math.min(dataPlan.left, 500) - 500);
        ring.style.backgroundPosition = '0 ' + colorIndicator + 'px';
      }
      this.applyDataUsagesCancel_ = null;
    }.bind(this)).catch(doNothing);
  }
};