'use strict';

class AbstractPlanPage extends AbstractPage {
  constructor(id) {
    super(id);
  }

  get templateData_() {
    return {};
  }

  registerListeners_() {
    super.registerListeners_();
    DataPlan.Events.onChanged.addListener(bindOnce(this.onPlanChanged_, this));
  }

  unregisterListeners_() {
    super.unregisterListeners_();
    DataPlan.Events.onChanged.removeListener(
        bindOnce(this.onPlanChanged_, this));
  }

  onPlanChanged_() {
    if (this.isVisible) {
      this.render();
    }
  }

  render() {
    renderTemplateIfNeeded(this.viewElement,
                           this.Templates.view(this.templateData_));
  }
};