'use strict';

class NonRenewableHomeView extends AbstractDataHomeView {
  constructor() {
    super(NonRenewableHomeView.ID);

    this.homePages_.push(NonRenewablePlanPage.ID);
    this.homePages_.push(OverbandwidthNonRenewablePlanPage.ID);

    this.registerListeners_();
    this.onCanShowChanged_();
  }

  get defaultHomePageID() {
    if (proxy.isEnabled) {
      if (dataPlan.isOverBandwidth) {
        return OverbandwidthNonRenewablePlanPage.ID;
      } else {
        return NonRenewablePlanPage.ID;
      }
    } else {
      return super.defaultHomePageID;
    }
  }

  get isShowable() {
    return !dataPlan.isRenewable && super.isShowable;
  }
};

NonRenewableHomeView.ID = 'home-non-renewable';
