'use strict';

class NonRenewablePlanPage extends AbstractDataPlanPage {
  constructor(id) {
    super(id || NonRenewablePlanPage.ID);

    this.registerListeners_();
  }

  get templateData_() {
    var data = super.templateData_;

    data.left = dataPlan.getDataAmountString(dataPlan.left);

    return data;
  }
};

NonRenewablePlanPage.Templates = class {
  static view(data) {
    return [
      'div', {
        'id': 'home-header-non-renewable',
        'class': 'data-ring'
      },
      ['div', {'class': 'ring-shadow'}],
      ['div', {'class': 'ring'}],
      ['div', {'class': 'ring-map'}],
      [
        'div', {
          'class': 'ring-content'
        },
        i18n.getTemplate('homeNonRenewablePlanDataAvailable', {
          '$1': [
            'strong',
             data.left
          ]
        })
      ]
    ];
  }
};

NonRenewablePlanPage.ID = 'non-renewable';