'use strict';

class RenewableHomeView extends AbstractDataHomeView {
  constructor() {
    super(RenewableHomeView.ID);

    this.homePages_.push(RenewablePlanPage.ID);
    this.homePages_.push(OverbandwidthRenewablePlanPage.ID);

    this.registerListeners_();
    this.onCanShowChanged_();
  }

  get defaultHomePageID() {
    if (proxy.isEnabled) {
      if (dataPlan.isOverBandwidth) {
        return OverbandwidthRenewablePlanPage.ID;
      } else {
        return RenewablePlanPage.ID;
      }
    } else {
      return super.defaultHomePageID;
    }
  }

  get isShowable() {
    return dataPlan.isRenewable && super.isShowable;
  }
};

RenewableHomeView.ID = 'home-renewable';