'use strict';

class RenewablePlanPage extends AbstractDataPlanPage {
  constructor(id) {
    super(id || RenewablePlanPage.ID);

    this.registerListeners_();
  }

  get templateData_() {
    var data = super.templateData_;

    data.left = dataPlan.getDataAmountString(dataPlan.left);
    data.total = dataPlan.getDataAmountString(dataPlan.total);
    data.used = dataPlan.getDataAmountString(dataPlan.used);
    data.daysToNewCycle = dataPlan.daysToNewCycle;


    return data;
  }
};

RenewablePlanPage.Templates = class {
  static dataRing(data) {
    return [
      'div', {
        'class': 'data-ring'
      },
      ['div', {'class': 'ring-shadow'}],
      ['div', {'class': 'ring'}],
      ['div', {'class': 'ring-map'}],
      [
        'div', {
          'class': 'ring-content'
        },
        i18n.getTemplate('homeRenewablePlanDataAvailable', {
          '$1': [
            'strong',
            data.left
          ]
        })
      ]
    ];
  }

  static dataDetails(data) {
    return [
      'div', {
        'class': 'ring-details'
      },
      ['h5', i18n.get('homeRenewablePlanRenewsInDays', [data.daysToNewCycle])],
      ['h3', i18n.get('homeRenewablePlanDataUsed', [data.used])]
    ];
  }

  static view(data) {
    return [
      'div', {
        'id': 'home-header-renewable'
      },
      this.dataRing(data),
      this.dataDetails(data)
    ];
  }
};

RenewablePlanPage.ID = 'renewable-plan';