'use strict';

class Popup extends AbstractSite {
  constructor() {
    super(Popup.ID);

    this.addPage(new IpPage());
    this.addPage(new LocationPage());
    this.addPage(new RewardsPage());
    this.addPage(new SideMenuPage());
    this.addPage(new LoginForm());
    this.addPage(new RegisterForm());
    this.addPage(new WelcomeRewardPage());
    this.addPage(new NumberRewardForm());
    this.addPage(new DisconnectedPlanPage());
    this.addPage(new JustConnectedPlanPage());
    this.addPage(new ExpiredPlanPage());
    this.addPage(new UnlimitedPlanPage());
    this.addPage(new RenewablePlanPage());
    this.addPage(new OverbandwidthRenewablePlanPage());
    this.addPage(new NonRenewablePlanPage());
    this.addPage(new OverbandwidthNonRenewablePlanPage());

    this.addView(new OnBoardingView());
    this.addView(new ErrorView());
    this.addView(new LoadingView());
    this.addView(new SignView());
    this.addView(new WelcomeRewardsView());
    this.addView(new UnlimitedHomeView());
    this.addView(new RenewableHomeView());
    this.addView(new NonRenewableHomeView());

    this.initialize();
  }


  initialize() {
    super.initialize();
    this.forceResize();
  }

  forceResize() {
    if (App.browserType === App.BROWSER_TYPE_CHROME) {
     var forceRelease = document.createElement('div');
     document.documentElement.appendChild(forceRelease);
      setTimeout(function() {
        forceRelease.style.height = '1px';
        setTimeout(function(){ forceRelease.remove(); }, 50);
      }, 50);
    }
  }
};

Popup.ID = 'popup';

document.addEventListener('DOMContentLoaded', function() {
  chrome.runtime.getBackgroundPage(function(backgroundPage) {
    window.Url = backgroundPage.Url;
    window.api = backgroundPage.api;
    window.App = backgroundPage.App;
    window.app = backgroundPage.app;
    window.analytics = backgroundPage.analytics;
    window.User = backgroundPage.User;
    window.user = backgroundPage.user;
    window.Device = backgroundPage.Device;
    window.device = backgroundPage.device;
    window.DataPlan = backgroundPage.DataPlan;
    window.dataPlan = backgroundPage.dataPlan;
    window.NetworkTask = backgroundPage.NetworkTask;
    window.networkTasks = backgroundPage.networkTasks;
    window.Geo = backgroundPage.Geo;
    window.geo = backgroundPage.geo;
    window.Reward = backgroundPage.Reward;
    window.Rewards = backgroundPage.Rewards;
    window.rewards = backgroundPage.rewards;
    window.Errors = backgroundPage.Errors;
    window.errors = backgroundPage.errors;
    window.OffRoad = backgroundPage.OffRoad;
    window.offroad = backgroundPage.offroad;
    window.sessionCookie = backgroundPage.sessionCookie;
    window.Proxy = backgroundPage.Proxy;
    window.proxy = backgroundPage.proxy;

    window.ToolbarState = backgroundPage.ToolbarState;
    window.toolbarState = backgroundPage.toolbarState;
    window.Notification = backgroundPage.Notification;
    window.Notifications = backgroundPage.Notifications;
    window.notifications = backgroundPage.notifications;

    window.site = new Popup();
  });
});



